/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.codehaus.activemq.store.bdbn;

import com.sleepycat.db.Db;
import com.sleepycat.db.DbEnv;
import com.sleepycat.db.DbException;
import org.codehaus.activemq.service.impl.PersistenceAdapterSupport;
import org.codehaus.activemq.store.MessageStore;
import org.codehaus.activemq.store.PreparedTransactionStore;
import org.codehaus.activemq.store.TopicMessageStore;
import org.codehaus.activemq.util.JMSExceptionHelper;

import javax.jms.JMSException;
import java.io.FileNotFoundException;
import java.util.Map;

/**
 * @version $Revision: 1.1 $
 */
public class BDbPersistenceAdapter extends PersistenceAdapterSupport {
    protected DbEnv environment;

    public BDbPersistenceAdapter(DbEnv environment) {
        this.environment = environment;
    }

    public Map getInitialDestinations() {
        return null;  /** TODO */
    }

    public MessageStore createQueueMessageStore(String destinationName) throws JMSException {
        return null; /** TODO */
    }

    public TopicMessageStore createTopicMessageStore(String destinationName) {
        return null; /** TODO */
    }

    public PreparedTransactionStore createPreparedTransactionStore() throws JMSException {
        return null;  /** TODO */
    }

    public void beginTransaction() throws JMSException {
        try {
            BDbHelper.createTransaction(environment);
        }
        catch (DbException e) {
            throw JMSExceptionHelper.newJMSException("Failed to commit transaction. Reason: " + e, e);
        }
    }

    public void commitTransaction() throws JMSException {
        BDbHelper.commitTransaction(BDbHelper.getTransaction());
    }

    public void rollbackTransaction() {
        BDbHelper.rollbackTransaction(BDbHelper.getTransaction());
    }

    public void start() throws JMSException {
    }

    public void stop() throws JMSException {
        try {
            environment.close(0);
        }
        catch (DbException e) {
            throw JMSExceptionHelper.newJMSException("Failed to close environment. Reason: " + e, e);
        }
    }

    // Implementation methods
    //-------------------------------------------------------------------------
    protected Db createDatabase(String name) throws JMSException, FileNotFoundException, DbException {
        return BDbHelper.open(environment, name, false);
    }

}
